/*
 * Generation of declaration elements such as parameters and members.
 *
 * Copyright (C) 2019, 2020 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <stdio.h>
#include "types.h"

/* Signatures. */

void write_interface_signature(struct signature *sig, enum signature_role role,
                               enum component_role component,
                               enum function_role function, FILE *fp,
                               struct interface *iface);

void write_interface_unimplemented_method(struct signature *sig,
                                          enum specifier direction, FILE *fp);

void write_initial_parameter(const char *name, FILE *fp);

void write_signatures(struct signature *sig, enum signature_role role, FILE *fp,
                      struct interface *iface,
                      void (*write_signature)(struct signature *,
                                              enum signature_role role,
                                              FILE *, struct interface *));
/* Parameter lists. */

void write_parameters(struct parameter *param, FILE *fp, enum parameter_role role,
                      enum function_role function, enum specifier direction,
                      int continuing);

void write_parameter(struct parameter *param, FILE *fp, enum parameter_role role,
                     enum function_role function);

/* Structure member and variable declaration/initialisation. */

void write_declarations(struct parameter *param, enum specifier direction,
                        enum parameter_class cls, FILE *fp);
